(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     25027,        708]
NotebookOptionsPosition[     22809,        661]
NotebookOutlinePosition[     23176,        677]
CellTagsIndexPosition[     23133,        674]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"pl2Cf", "[", 
   RowBox[{"mat_List", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rule", ",", "cellconf", ",", "blank"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rule", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], "}"}], "\[Rule]", "1"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}], "}"}], "\[Rule]", "2"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"1", ",", "3"}], "}"}], "}"}], "\[Rule]", "3"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"1", ",", "4"}], "}"}], "}"}], "\[Rule]", "4"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1"}], "}"}], "}"}], "\[Rule]", "8"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2"}], "}"}], "}"}], "\[Rule]", "7"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3"}], "}"}], "}"}], "\[Rule]", "6"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"2", ",", "4"}], "}"}], "}"}], "\[Rule]", "5"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"3", ",", "1"}], "}"}], "}"}], "\[Rule]", "9"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"3", ",", "2"}], "}"}], "}"}], "\[Rule]", "10"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"3", ",", "3"}], "}"}], "}"}], "\[Rule]", "11"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"3", ",", "4"}], "}"}], "}"}], "\[Rule]", "12"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"4", ",", "1"}], "}"}], "}"}], "\[Rule]", "16"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"4", ",", "2"}], "}"}], "}"}], "\[Rule]", "15"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"4", ",", "3"}], "}"}], "}"}], "\[Rule]", "14"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"4", ",", "4"}], "}"}], "}"}], "\[Rule]", "13"}]}], 
       "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"cellconf", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"mat", ",", "#"}], "]"}], "&"}], "/@", 
         RowBox[{"Range", "[", "15", "]"}]}], ")"}], "/.", "rule"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"blank", "=", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{"mat", ",", "#"}], "]"}], "&"}], "@", "\"\< \>\""}], "/.", 
       "rule"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"#", ">", "blank"}], ",", 
         RowBox[{"#", "-", "1"}], ",", "#"}], "]"}], " ", "&"}], " ", "/@", 
      "cellconf"}]}]}], "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752821461523123*^9, 3.752821795519621*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"2b1b8bcc-3375-4dab-bd4d-41188fabdf7d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"findPermutationReplace", "[", 
   RowBox[{"lst1_", ",", "lst2_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"lst1", "[", 
      RowBox[{"[", "#", "]"}], "]"}], " ", "&"}], ",", " ", 
    RowBox[{"FindPermutation", "[", 
     RowBox[{"lst2", ",", "lst1"}], "]"}], ",", 
    RowBox[{"{", "3", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"permutationSignature", "[", 
   RowBox[{"perm_", "?", "PermutationCyclesQ"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Apply", "[", 
   RowBox[{"Times", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", " ", "/@", 
        RowBox[{"First", "[", "perm", "]"}]}], "-", "1"}], ")"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"parityQ", "[", 
   RowBox[{
    RowBox[{"x_List", "?", "MatrixQ"}], ",", 
    RowBox[{"y_List", "?", "MatrixQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  
  RowBox[{"permutationSignature", "[", 
   RowBox[{"findPermutationReplace", "[", 
    RowBox[{
     RowBox[{"pl2Cf", "[", "x", "]"}], ",", 
     RowBox[{"pl2Cf", "[", "y", "]"}]}], "]"}], "]"}]}]}], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752821824663048*^9, 3.752822004660726*^9}, {
  3.752841335204928*^9, 3.752841335924509*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"2ef0daf7-5daa-4394-a3fa-3dc720d6a5fa"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"viewlolol", "[", "a_List", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"MatrixForm", "[", 
       RowBox[{"#", ",", 
        RowBox[{"TableSpacing", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}], " ", "&"}], ",", " ", 
     "a"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"desired", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Range", "[", "16", "]"}], " ", "/.", 
      RowBox[{"{", 
       RowBox[{"16", "\[Rule]", "\"\< \>\""}], "}"}]}], ",", "4"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752822015263185*^9, 3.752822077851467*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"d8e9c00c-e1eb-4a9e-981d-a15465d28e3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"moves", "[", 
   RowBox[{"current_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "answer", ",", "xdim", ",", "ydim", ",", "place", ",", "xpos", ",", 
      "ypos"}], "}"}], ",", 
    RowBox[{
     RowBox[{"answer", "=", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Up\>\"", ",", "\"\<Down\>\"", ",", "\"\<Left\>\"", ",", 
        "\"\<Right\>\""}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ydim", "=", 
      RowBox[{"Length", "[", "current", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"xdim", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"current", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"place", "=", 
      RowBox[{"Position", "[", 
       RowBox[{"current", ",", "\"\< \>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"xpos", "=", 
      RowBox[{"place", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ypos", "=", 
      RowBox[{"place", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"xpos", "\[Equal]", "xdim"}], ",", 
       RowBox[{"answer", "=", 
        RowBox[{"Drop", "[", 
         RowBox[{"answer", ",", 
          RowBox[{"{", "4", "}"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"xpos", "\[Equal]", "1"}], ",", 
       RowBox[{"answer", "=", 
        RowBox[{"Drop", "[", 
         RowBox[{"answer", ",", 
          RowBox[{"{", "3", "}"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ypos", "\[Equal]", "ydim"}], ",", 
       RowBox[{"answer", "=", 
        RowBox[{"Drop", "[", 
         RowBox[{"answer", ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"ypos", "\[Equal]", "1"}], ",", 
       RowBox[{"answer", "=", 
        RowBox[{"Drop", "[", 
         RowBox[{"answer", ",", 
          RowBox[{"{", "1", "}"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", "answer"}]}], "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.7528241580193768`*^9, 3.75282415802181*^9}, {
   3.7528242042606792`*^9, 3.752824488212582*^9}, {3.752824530375502*^9, 
   3.7528245555409813`*^9}, {3.752840186010028*^9, 3.752840193294016*^9}, {
   3.752840390350623*^9, 3.7528403911516027`*^9}, 3.7528405231429234`*^9},
 CellLabel->"In[22]:=",ExpressionUUID->"198a3fd8-8421-4a39-8942-f71dbfa2cc96"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"effectmove", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a___", ",", 
       RowBox[{"{", 
        RowBox[{"b___", ",", "\"\< \>\"", ",", "c_", ",", "d___"}], "}"}], 
       ",", "e___"}], "}"}], ",", "\"\<Right\>\""}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", "c", ",", "\"\< \>\"", ",", "d"}], "}"}], ",", "e"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"effectmove", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a___", ",", 
       RowBox[{"{", 
        RowBox[{"b___", ",", "c_", ",", "\"\< \>\"", ",", "d___"}], "}"}], 
       ",", "e___"}], "}"}], ",", "\"\<Left\>\""}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", "\"\< \>\"", ",", "c", ",", "d"}], "}"}], ",", "e"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"effectmove", "[", 
    RowBox[{"a_", ",", "\"\<Up\>\""}], "]"}], ":=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"effectmove", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "a", "]"}], ",", "\"\<Left\>\""}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"effectmove", "[", 
    RowBox[{"a_", ",", "\"\<Down\>\""}], "]"}], ":=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"effectmove", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "a", "]"}], ",", "\"\<Right\>\""}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"effectmove", "[", 
    RowBox[{"a_List", ",", "b_String", ",", "c__String"}], "]"}], ":=", 
   RowBox[{"effectmove", "[", 
    RowBox[{
     RowBox[{"effectmove", "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", "c"}], "]"}]}], ";"}]}], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752824649480914*^9, 3.7528247897386093`*^9}, {
  3.752824917007848*^9, 3.752825063774275*^9}, {3.7528370047951527`*^9, 
  3.752837028036457*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"d62093d5-2af4-4af8-baa0-fc7415f381db"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"manhattandistance", "::", "incompat"}], "=", 
   "\"\<Manhattan distance can only be computed\nfor matrices with tha same \
dimension\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"manhattandistance", "[", 
   RowBox[{"x_List", ",", "y_List"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "temp", "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Dimensions", "[", "x", "]"}], "\[NotEqual]", 
       RowBox[{"Dimensions", "[", "y", "]"}]}], ",", 
      RowBox[{"Message", "[", 
       RowBox[{"manhattandistance", "::", "incompat"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"temp", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"Position", "[", 
             RowBox[{"y", ",", "#"}], "]"}], "]"}], "&"}], ",", "x", ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}], ";", 
       RowBox[{"temp", "=", 
        RowBox[{"temp", "-", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{"Position", "[", 
              RowBox[{"x", ",", "#"}], "]"}], "]"}], "&"}], ",", "x", ",", 
           RowBox[{"{", "2", "}"}]}], "]"}]}]}], ";", 
       RowBox[{"temp", "=", 
        RowBox[{"Total", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"Abs", "[", "temp", "]"}], "]"}], "]"}]}]}]}], "]"}]}], 
   "]"}]}]}], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.7528250853954353`*^9, 3.752825314977932*^9}, 
   3.7528253477147093`*^9},
 CellLabel->"In[28]:=",ExpressionUUID->"cfe0ed1c-9c74-4a08-acf2-cc5263bb062d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"listscores", "[", "x_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"makemoves", ",", "ans"}], "}"}], ",", 
    RowBox[{
     RowBox[{"makemoves", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"effectmove", "[", 
           RowBox[{"x", ",", "#"}], "]"}], "}"}], "&"}], ",", 
        RowBox[{"moves", "[", "x", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ans", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"manhattandistance", "[", 
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "desired"}], "]"}], "&"}], 
         ",", "makemoves"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"ans", ",", 
        RowBox[{"moves", "[", "x", "]"}]}], "}"}], "]"}]}]}], 
   "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752825352038953*^9, 3.7528253520409107`*^9}, {
   3.7528254637204742`*^9, 3.7528254761356707`*^9}, 3.752840829069927*^9},
 CellLabel->"In[30]:=",ExpressionUUID->"4f011ca2-838f-407c-87ce-a6131b100cc6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"worthwhile", "[", 
    RowBox[{"{", 
     RowBox[{"x___", ",", "\"\<Right\>\"", ",", "\"\<Left\>\""}], "}"}], 
    "]"}], ":=", "False"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"worthwhile", "[", 
    RowBox[{"{", 
     RowBox[{"x___", ",", "\"\<Left\>\"", ",", "\"\<Right\>\""}], "}"}], 
    "]"}], ":=", "False"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"worthwhile", "[", 
    RowBox[{"{", 
     RowBox[{"x___", ",", "\"\<Up\>\"", ",", "\"\<Down\>\""}], "}"}], "]"}], ":=",
    "False"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"worthwhile", "[", 
    RowBox[{"{", 
     RowBox[{"x___", ",", "\"\<Down\>\"", ",", "\"\<Up\>\""}], "}"}], "]"}], ":=",
    "False"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"worthwhile", "[", 
   RowBox[{"{", "x___", "}"}], "]"}], ":=", "True"}]}], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752825615458685*^9, 3.752825615460619*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"e9a986f6-079c-4d5b-98cd-1723d5a328fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"bestscore", "[", 
   RowBox[{"x_List", ",", "y_List", ",", 
    RowBox[{"delta_:", "0.2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "<", 
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "+", 
      RowBox[{"delta", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"Rest", "[", "y", "]"}], "]"}], "-", 
         RowBox[{"Length", "[", 
          RowBox[{"Rest", "[", "x", "]"}], "]"}]}], ")"}]}]}]}], ",", "True", 
    ",", "False"}], "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.7528256784281597`*^9, 3.752825686939164*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"bda42ce7-c02e-44b1-81bd-3ee378922c54"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"iterate", "[", 
     RowBox[{"start_", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x_", ",", "y__"}], "}"}], ",", "z___"}], "}"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"endnode", ",", "newnodes", ",", "newseq"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"endnode", "=", 
        RowBox[{"effectmove", "[", 
         RowBox[{"start", ",", "y"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"newnodes", "=", 
        RowBox[{"listscores", "[", "endnode", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"newseq", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"First", "[", "#", "]"}], "}"}], ",", 
             RowBox[{"{", "y", "}"}], ",", 
             RowBox[{"Rest", "[", "#", "]"}]}], "]"}], "&"}], ",", 
          "newnodes"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Sort", "[", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Select", "[", 
            RowBox[{"newseq", ",", "worthwhile"}], "]"}], ",", 
           RowBox[{"{", "z", "}"}]}], "]"}], ",", "bestscore"}], "]"}]}]}], 
     "]"}]}], ";"}], "\n"}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752825763274704*^9, 3.752825775658074*^9}, {
  3.75284084580704*^9, 3.752840862047721*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"8d6e95e8-3f3c-46ae-9239-b7e5c8abbf8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"try", "[", 
   RowBox[{"start_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"temp", ",", "count"}], "}"}], ",", 
    RowBox[{
     RowBox[{"count", "=", "0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"temp", "=", 
      RowBox[{"listscores", "[", "start", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"temp", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ">", "0"}], "&&", 
        RowBox[{"count", "<", "n"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp", "=", 
         RowBox[{"iterate", "[", 
          RowBox[{"start", ",", "temp"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"count", "=", 
         RowBox[{"count", "+", "1"}]}]}]}], "]"}], ";", "\n", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"count", "\[Equal]", "n"}], "&&", 
        RowBox[{
         RowBox[{"temp", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], "\[NotEqual]", "0"}]}], ",", 
       RowBox[{
       "Print", "[", "\"\<Solution not found, best sequence was\>\"", "]"}], 
       ",", 
       RowBox[{
       "Print", "[", "\"\<The following solution was found\>\"", "]"}]}], 
      "]"}], ";", "\n", 
     RowBox[{"temp", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752825858627454*^9, 3.752825915637638*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"02c66dc0-6eeb-43f6-b4c5-527bb82f72b8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"findPermutationReplace", "[", 
   RowBox[{"lst1_", ",", "lst2_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"lst1", "[", 
      RowBox[{"[", "#", "]"}], "]"}], "&"}], ",", 
    RowBox[{"FindPermutation", "[", 
     RowBox[{"lst2", ",", "lst1"}], "]"}], ",", 
    RowBox[{"{", "3", "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"toList", "[", "mat_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Flatten", "[", "mat", "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{"\"\< \>\"", "\[Rule]", "16"}], "}"}]}]}], "\n", 
 RowBox[{
  RowBox[{"puzseq2cycles", "[", "puzseq_", "]"}], ":=", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"findPermutationReplace", "[", 
      RowBox[{
       RowBox[{"toList", "[", "#1", "]"}], ",", 
       RowBox[{"toList", "[", "#2", "]"}]}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Most", "[", "puzseq", "]"}], ",", 
      RowBox[{"Rest", "[", "puzseq", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.752826034731614*^9, 3.752826034734047*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"bb8e9603-9881-4cc8-83df-9f877eec2efc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"desired", "=", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Range", "[", "16", "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{"16", "\[Rule]", "\"\< \>\""}], "}"}]}], ",", "4"}], "]"}]}], 
   ")"}], "//", "MatrixForm"}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.7528367166715317`*^9, 3.7528367210181932`*^9}, {
  3.752836823778791*^9, 3.752836858258713*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"1a5d4038-f824-41c9-8d1f-6eaafb13327b"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "2", "3", "4"},
     {"5", "6", "7", "8"},
     {"9", "10", "11", "12"},
     {"13", "14", "15", "\<\" \"\>"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 InitializationGroup->True,
 CellChangeTimes->{
  3.752836721668228*^9, {3.752836824688217*^9, 3.752836860154418*^9}, 
   3.752840401926257*^9, 3.752884296656405*^9},
 CellLabel->
  "Out[42]//MatrixForm=",ExpressionUUID->"ea7110a2-82b3-45ea-9b5e-\
a2235d42cce7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"moves", "[", "desired", "]"}]], "Input",
 CellChangeTimes->{{3.752836726448516*^9, 3.75283673268502*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"0bf7abc3-e2cb-468c-8c11-6ceef4977174"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Up\"\>", ",", "\<\"Left\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.7528367333128157`*^9, 3.752836862029613*^9, 
  3.75283710171881*^9, 3.752840213609933*^9, 3.75284040425871*^9, 
  3.752840532659576*^9, 3.7528842968543453`*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"cdbf4602-94ee-420e-9a0e-0d04a9a3265c"]
}, Open  ]]
},
WindowSize->{809, 751},
WindowMargins->{{Automatic, 183}, {Automatic, 26}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (2018\:5e743\
\:670812\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 3601, 105, 215, "Input",ExpressionUUID->"2b1b8bcc-3375-4dab-bd4d-41188fabdf7d",
 InitializationGroup->True],
Cell[4162, 127, 1472, 40, 196, "Input",ExpressionUUID->"2ef0daf7-5daa-4394-a3fa-3dc720d6a5fa",
 InitializationGroup->True],
Cell[5637, 169, 832, 24, 80, "Input",ExpressionUUID->"d8e9c00c-e1eb-4a9e-981d-a15465d28e3e",
 InitializationGroup->True],
Cell[6472, 195, 2746, 71, 382, "Input",ExpressionUUID->"198a3fd8-8421-4a39-8942-f71dbfa2cc96",
 InitializationGroup->True],
Cell[9221, 268, 2069, 59, 145, "Input",ExpressionUUID->"d62093d5-2af4-4af8-baa0-fc7415f381db",
 InitializationGroup->True],
Cell[11293, 329, 1758, 46, 215, "Input",ExpressionUUID->"cfe0ed1c-9c74-4a08-acf2-cc5263bb062d",
 InitializationGroup->True],
Cell[13054, 377, 1282, 35, 116, "Input",ExpressionUUID->"4f011ca2-838f-407c-87ce-a6131b100cc6",
 InitializationGroup->True],
Cell[14339, 414, 1028, 30, 188, "Input",ExpressionUUID->"e9a986f6-079c-4d5b-98cd-1723d5a328fc",
 InitializationGroup->True],
Cell[15370, 446, 823, 23, 65, "Input",ExpressionUUID->"bda42ce7-c02e-44b1-81bd-3ee378922c54",
 InitializationGroup->True],
Cell[16196, 471, 1638, 44, 181, "Input",ExpressionUUID->"8d6e95e8-3f3c-46ae-9239-b7e5c8abbf8d",
 InitializationGroup->True],
Cell[17837, 517, 1648, 44, 238, "Input",ExpressionUUID->"02c66dc0-6eeb-43f6-b4c5-527bb82f72b8",
 InitializationGroup->True],
Cell[19488, 563, 1195, 33, 137, "Input",ExpressionUUID->"bb8e9603-9881-4cc8-83df-9f877eec2efc",
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[20708, 600, 544, 14, 44, "Input",ExpressionUUID->"1a5d4038-f824-41c9-8d1f-6eaafb13327b",
 InitializationGroup->True],
Cell[21255, 616, 936, 26, 94, "Output",ExpressionUUID->"ea7110a2-82b3-45ea-9b5e-a2235d42cce7",
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[22228, 647, 208, 3, 30, "Input",ExpressionUUID->"0bf7abc3-e2cb-468c-8c11-6ceef4977174"],
Cell[22439, 652, 354, 6, 34, "Output",ExpressionUUID->"cdbf4602-94ee-420e-9a0e-0d04a9a3265c"]
}, Open  ]]
}
]
*)

